﻿using System;
using System.IO;
using System.Configuration;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net.Mail;
using System.Data.SqlClient;
using System.Data;
using System.Web.Security;

namespace MembershipManager.security
{
    public partial class create_user : System.Web.UI.Page
    {
        protected void  CreateUserWizard1_CreatedUser(object sender, System.EventArgs e)
        {
            Roles.AddUserToRole(CreateUserWizard1.UserName, "users");
        }

        protected void  CreateUserWizard1_NextButtonClick(object sender, System.Web.UI.WebControls.WizardNavigationEventArgs e)
        {
            string company = ((TextBox)CreateUserWizard1.CreateUserStep.ContentTemplateContainer.FindControl("Company")).Text;
            //TextBox Company = CreateUserWizard1.FindControl["Company"];
            //if (string.IsNullOrEmpty(company.ToString()))
            //{
            //    company.Text = "None";
            //}
        }

        //Handles CreateUserWizard1.SendingMail
        protected void CreateUserWizard1_SendingMail(object sender, System.Web.UI.WebControls.MailMessageEventArgs e)
        {
            DataTable UserData = default(DataTable);
            string sql = "SELECT aspnet_Membership.UserId, aspnet_Users.UserName, aspnet_Membership.PasswordQuestion, aspnet_Membership.PasswordAnswer FROM aspnet_Membership INNER JOIN aspnet_Users ON aspnet_Membership.UserId = aspnet_Users.UserId WHERE aspnet_Users.UserName = '{0}'";
            sql = String.Format(sql, CreateUserWizard1.UserName);
            UserData = GetRoleData(sql);
            DataRow newUser = UserData.Rows[0];


            //*********************************************************************************************
            //*** If you want to send a confirmation email, uncomment these lines and populate as required
            //*********************************************************************************************

            //Dim NoReply As New MailAddress(Session["NoReplyAddress"], Session["CompanyName"])
            //e.Message.From = NoReply
            //e.Message.Body = e.Message.Body.Replace("<%FirstName%>", Trim(CType(CreateUserWizard1.FindControl("FirstName"), TextBox).Text))
            //e.Message.Body = e.Message.Body.Replace("<%LastName%>", Trim(CType(CreateUserWizard1.FindControl("LastName"), TextBox).Text))
            //e.Message.Body = e.Message.Body.Replace("<%CompanyName%>", Session["CompanyName"])
            //e.Message.Body = e.Message.Body.Replace("<%PasswordQuestion%>", CreateUserWizard1.Question)
            //e.Message.Body = e.Message.Body.Replace("<%PasswordAnswer%>", newUser("PasswordAnswer").ToString)
        }

        
        protected void  Page_Load(object sender, System.EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                CreateUserWizard1.FindControl("FirstName").Focus();
            }
            WizardStep RoleStep = CreateUserWizardStep2;
            if (!User.IsInRole("administrators"))
            {
                CreateUserWizard1.WizardSteps.Remove(RoleStep);
            }
        }

        private DataTable GetRoleData(string query)
        {
            SqlConnection dbCon = new SqlConnection(ConfigurationManager.ConnectionStrings["MembershipConnectionString"].ConnectionString);
            dbCon.Open();

            SqlDataAdapter adapter = new SqlDataAdapter(query, dbCon);
            DataTable dt = new DataTable();
            adapter.Fill(dt);
            dbCon.Close();

            return dt;
        }
        //GetRoleData

        private void LoadRoles()
        {
            DataTable dt = GetRoleData("SELECT * FROM aspnet_Roles ORDER BY RoleName");
            CheckBoxList1.DataSource = dt;
            CheckBoxList1.DataTextField = "RoleName";
            CheckBoxList1.DataValueField = "RoleID";
            CheckBoxList1.DataBind();

            string Query = "SELECT aspnet_Users.UserName, aspnet_Users.UserId, aspnet_Roles.RoleName FROM aspnet_UsersInRoles INNER JOIN aspnet_Users ON aspnet_UsersInRoles.UserId = aspnet_Users.UserId INNER JOIN aspnet_Roles ON aspnet_UsersInRoles.RoleId = aspnet_Roles.RoleId WHERE (aspnet_Users.UserName = '{0}')";
            Query = String.Format(Query, CreateUserWizard1.UserName);
            DataTable roles = GetRoleData(Query);

            foreach (DataRow row in roles.Rows)
            {
                ListItem RoleBox = CheckBoxList1.Items.FindByText("RoleName");
                RoleBox.Selected = true;
                if (RoleBox.Text == "users")
                {
                    RoleBox.Enabled = false;
                }
            }
        }

        protected void  CreateUserWizardStep2_Deactivate(object sender, System.EventArgs e)
        {
            foreach (ListItem rolebox in CheckBoxList1.Items)
            {
                if (rolebox.Selected == true)
                {
                    if (!Roles.IsUserInRole(CreateUserWizard1.UserName, rolebox.Text))
                    {
                        Roles.AddUserToRole(CreateUserWizard1.UserName, rolebox.Text);
                    }
                }
                else
                {
                    if (Roles.IsUserInRole(CreateUserWizard1.UserName, rolebox.Text))
                    {
                        Roles.RemoveUserFromRole(CreateUserWizard1.UserName, rolebox.Text);
                    }
                }
            }
        }
    }
}