﻿<%@ Page Title="" Language="C#" MasterPageFile="~/security/security.master" AutoEventWireup="true" CodeBehind="login.aspx.cs" Inherits="MembershipManager.security.login" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">

            <table border="0" cellpadding="0" cellspacing="10" width="500" class="LoginOuterBox">
                <tr>
                    <td width="125" align="left" valign="top" id="LoginIntro">
                        <img src="../images/icons/admin_2_unlock_48.gif" /><br /><br />
                        <h2>user Login</h2>
                        <p>Use a valid username and password to gain access.</p>
                        <p style="line-height:3em;">
                            <a href="create-user.aspx"><img src="../images/icons/user_2_add_24.gif" align="absmiddle" border="0" /> create new user &raquo;</a><br />
                            <a href="change-password.aspx"><img src="../images/icons/lock_write_24.gif" align="absmiddle" border="0" /> change password &raquo;</a>                            
                        </p>
                    </td>
                    
                    <td>
                        <asp:LoginView ID="LoginView1" runat="server">
                        <AnonymousTemplate>
                    <asp:Login ID="Login1" runat="server" MembershipProvider="SqlMembershipProvider" PasswordRecoveryUrl="password-recovery.aspx" PasswordRecoveryIconUrl="../images/icons/lock_help_32.gif" PasswordRecoveryText="Forgot Password?" Width="100%" UserNameRequiredErrorMessage="Username is required." UserNameLabelText="Username" DestinationPageUrl="~/security/login.aspx" FailureTextStyle-ForeColor="Red">
                        <LayoutTemplate>
                            <h2>Secure Login</h2>
                                <table border="1" cellpadding="15" cellspacing="0" class="LoginBox">
                                    <tr>
                                        <td align="left">
                                            <img src="../images/icons/lock_48.gif" align="right" style="margin-bottom: 20px"/>
                                            <asp:Label ID="UserNameLabel" runat="server" AssociatedControlID="UserName" Font-Bold="true">Username</asp:Label><br />
                                            <asp:TextBox ID="UserName" runat="server" Width="200"></asp:TextBox>
                                            <asp:RequiredFieldValidator ID="UserNameRequired" runat="server" ControlToValidate="UserName" ErrorMessage="User Name is required." ToolTip="User Name is required." ValidationGroup="Login1">*</asp:RequiredFieldValidator>
                                            <br /><br />

                                            <asp:Label ID="PasswordLabel" runat="server" AssociatedControlID="Password" Font-Bold="true">Password</asp:Label><br />    
                                            <asp:TextBox ID="Password" runat="server" TextMode="Password" Width="200"></asp:TextBox>
                                            <asp:RequiredFieldValidator ID="PasswordRequired" runat="server" ControlToValidate="Password" ErrorMessage="Password is required." ToolTip="Password is required." ValidationGroup="Login1">*</asp:RequiredFieldValidator>
                                            <br />
                                            
                                            <asp:CheckBox ID="RememberMe" runat="server" Text="Remember me next time." />
                                            <br /> 
                                                                                               
                                            <div style="color: Red;">
                                                <asp:Literal ID="FailureText" runat="server" EnableViewState="False"></asp:Literal>
                                            </div>
                                            <br />
                                            
                                            <div style="float:right; font: normal 1em arial">
                                                <a href="password-recovery.aspx">forgot password? <img src="../images/icons/lock_help_24.gif" align="absBottom" border="0" /></a>
                                            </div>
                                            <asp:Button ID="LoginButton" runat="server" CommandName="Login" Text="Login" ValidationGroup="Login1"  CssClass="LoginButton"/>
                                         </td>
                                    </tr>
                                </table>
                        </LayoutTemplate>
                    </asp:Login>
                    </AnonymousTemplate>
                    <LoggedInTemplate>
                            <h2>Active User: <asp:LoginName ID="LoginName1" runat="server" ForeColor="black" /></h2>
                                <table border="1" cellpadding="15" cellspacing="0" class="LoginBox">
                                    <tr>
                                        <td align="left">
                                        <div id="statusDiv">
                                        <img src="../images/icons/unlock_48.gif" align="right" style="margin-bottom: 20px"/>
                                        <p><b>Status</b></p>
                                            <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" >
                                                <asp:View ID="AdminRole" runat="server">
                                                    <p>You are successfully logged in and may use the administration console.</p>
                                                    <p>If you encounter any problems, please report them immediately to <a href="mailto:support@bsolveit.com?subject=Problem with CMSeo3.0">support@bsolveit.com</a></p>
                                                    <p><b>Last Login Date:</b> &nbsp;<asp:Label ID="lblLastLoginDate1" runat="server" text=""></asp:Label></p>
                                                    <br />
                                                    <asp:LoginStatus ID="LoginStatus1" runat="server" />  &nbsp; &nbsp; 
                                                    <asp:HyperLink ID="admin" runat="server" NavigateUrl="~/default.aspx">Launch Admin Console</asp:HyperLink> 
                                                </asp:View>
                                                <asp:View ID="PublishersRole"  runat="server" >
                                                    <p>You are successfully logged in with a publishers account.</p>
                                                    <p>With your access rights you can administer the imported legal articles and briefings, but nothing else.</p>
                                                    <p><b>Last Login Date:</b> &nbsp;<asp:Label ID="lblLastLoginDate2" runat="server" text=""></asp:Label></p>
                                                    <br />
                                                     <p style="color:red">You do not have Full Administrative rights.</p>
                                                     <asp:LoginStatus ID="LoginStatus3" runat="server" />  &nbsp;&nbsp; 
                                                     <asp:HyperLink ID="HyperLink1" runat="server" NavigateUrl="~/admin/publishers/legalarticles.aspx">Article Admin</asp:HyperLink> &nbsp;&nbsp; 
                                                     <asp:HyperLink ID="HyperLink2" runat="server" NavigateUrl="~/admin/publishers/legalbriefings.aspx">Briefings Admin</asp:HyperLink> 
                                                </asp:View>
                                                <asp:View ID="NotInRole"  runat="server" >
                                                    <p>You are successfully logged in with a restricted account.</p>
                                                    <p>It is likely that you have a new account that has not yet been granted the appropriate rights.  You should contact your system administrator.</p>
                                                    <p><b>Last Login Date:</b> &nbsp;<asp:Label ID="lblLastLoginDate3" runat="server" text=""></asp:Label></p>
                                                    <br />
                                                     <p style="color:red">You do not have Administrative rights.</p>
                                                     <asp:LoginStatus ID="LoginStatus2" runat="server" /> 
                                                </asp:View>
                                            </asp:MultiView>
                                            </div>
                                        </td>
                                    </tr>
                                </table>
                    </LoggedInTemplate>
                    </asp:LoginView>
                    </td>
                </tr>
            </table>
</asp:Content>

